import logging

from pylons import request, response, session, tmpl_context as c, url
from pylons.controllers.util import abort, redirect

import webhelpers.paginate as paginate

from mapwocgui.lib.base import BaseController, render

from mapwocgui.model import Session
from mapwoc.lib.result import Visit, Result, ResultType
from mapwoc.lib.url import URL
import mapwoc.lib.model.result

log = logging.getLogger(__name__)

class ResultController(BaseController):

    def index(self):
        results = Session.query(Result)
        c.result_paginator = paginate.Page(results,
                                 page=int(request.params.get('page', 1)),
                                 items_per_page=30,)
        c.resulttypes = Session.query(ResultType).all()
        return render('/result/index_result.mako')

    def by_type(self, id):
        query = Session.query(Result).filter_by(result_type_id=id)
        c.resulttypes = Session.query(ResultType).all()
        c.result_type_filter_id = id
        c.result_paginator = paginate.Page(query,
                                 page=int(request.params.get('page', 1)),
                                 items_per_page=30,)
        return render('/result/index_result.mako')

    def by_url(self, id):
        c.results = Session.query(Result).all()
        c.resulttypes = Session.query(ResultType).all()
        return render('/result/index_result.mako')

    def view(self, id):
        c.result = Session.query(Result).filter_by(id=id).first()
        if c.result is None:
            abort(404)
        return render('/result/view_result.mako')

    def view_dummy(self):
        return render('/result/view_result.mako')
